
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%Estimation file: "Estimation and Inference in Additively Separable
%Conditional Expectation Models with a High Dimensional Component"

%ACT Example

%Large interaction expansion

%y = g0(x) + h0(z) + e

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

         
load result_lasso_iter_1-21799.mat
load act_data


n=length(Y);
         y = Y-mean(Y);
         x = [X1-mean(X1),X2-mean(X2),X3-mean(X3),X4-mean(X4)];
    
         
%Construct dictionaries
       
%K_est= generate_p_ACT(y,x,Z_Controls(:,S_lasso_RF~=0));
K_est = 6;

pX1 = generate_p_fixed_K((X1-mean(X1)),K_est);
pX2 = generate_p_fixed_K((X2-mean(X2)),K_est);
pX3 = generate_p_fixed_K((X3-mean(X3)),K_est);
pX4 = generate_p_fixed_K((X4-mean(X4)),K_est);

P1=[];for k=1:K_est, P1=[P1,pX1{k}((X1-mean(X1)))]; end;%#ok
P2=[];for k=1:K_est, P2=[P2,pX2{k}((X2-mean(X2)))]; end;%#ok
P3=[];for k=1:K_est, P3=[P3,pX3{k}((X3-mean(X3)))]; end;%#ok
P4=[];for k=1:K_est, P4=[P4,pX4{k}((X4-mean(X4)))]; end;%#ok

P = [P1,P2,P3,P4];
K = size(P,2);


    
    Q=Z_Controls(:,s_lasso==1);
    
    %clear Z_Controls

p=cell(1,K);
    for k = 1:K_est
        p{k + 0*K_est} = @(x)pX1{k}(x(:,1));
        p{k + 1*K_est} = @(x)pX1{k}(x(:,2));
        p{k + 2*K_est} = @(x)pX1{k}(x(:,3));
        p{k + 3*K_est} = @(x)pX1{k}(x(:,4));
    end
    
    
    
    
    
    
    %Post Selection Estimation

    [ghat, thetahat, Vhat,se,BIC] = nonpar_simple_ACT_example(y,x,p,K,Q);
   
    
    %Dispay
    disp('----------------------------')
    disp('Average Derivative Estimates')
    disp(' ')
    disp(thetahat)
    disp(' ')
    disp('Standard Errors')
    disp(' ')
    disp(se)
    disp( ' ')
    
    
    
    
    
    