function [Y, X1, X2, X3, X4, Z_Controls] = act_stata2mat_data_extraction(srcfile, destfile)
    % act_stata2mat_data_extraction
    %
    % extracts the data from the csv and saves a .mat file
    importer = importdata(srcfile, ',', 1);

    act_data = importer.data;

    [orData, andData, hwData] = interaction_expansion_act(act_data(:, 6:end));

    Y = act_data(:, 1);
    X1 = act_data(:, 2);
    X2 = act_data(:, 3);
    X3 = act_data(:, 4);
    X4 = act_data(:, 5);
    Z_Controls = [orData, andData, hwData];
    
    save(destfile, 'Y', 'X1', 'X2', 'X3', 'X4', 'Z_Controls', '-v7.3');    
end
