function collect_lasso_result(resultfolder, filenamePattern, preproDatafile)

    %% load data from preprocessing
    loader = load(fullfile(resultfolder, preproDatafile), 'scoreControls', 's_lasso_rf', 's_lasso_fs', 's_fs_all');
    scoreControls = loader.scoreControls;
    s_lasso_rf = loader.s_lasso_rf;
    s_lasso_fs = loader.s_lasso_fs;
    s_fs_all = loader.s_fs_all;
    clear loader

    %% list all files with the passed filename pattern (* --> wildcard)
    files = dir(fullfile(resultfolder, filenamePattern));

    %% load s_lasso variable from all files and use the or operator to get the s_blanket variable
    s_blanket = sparse(false);
    for curFile = 1:numel(files)
        data = load(fullfile(files(curFile).folder, files(curFile).name));
        s_blanket = s_blanket | data.s_lasso;
    end

    Q = scoreControls(:, any([s_lasso_rf, s_lasso_fs, s_fs_all, s_blanket], 2));

    [~, folderName] = fileparts(resultfolder);
    save(fullfile(resultfolder, sprintf('%s.mat', folderName)), 'Q', '-v7.3');
end