function s_lasso = lasso_hetero_large(y_std, x_std, alpha, c_tau)
    % lasso_hetero_large: function for running the lasso
    
    %% Initialize
    [n, p] = size(x_std);

    normLoad = x_std ./ sqrt(sum((y_std .* x_std) .^ 2 ./ n));
    lambda = 2 .* c_tau .* sqrt(1 ./ n) .* norminv(1 - alpha ./ p);

    %% Estimate Lasso
    theta_lasso = lasso(normLoad, y_std, 'Lambda', lambda);
    
    s_lasso = abs(theta_lasso) > 0.01;
