
function [ghat, thetahat, Vhat, se, BIC, betahat_h]=nonpar_simple_ACT_example(y,x,p,K,Q)



n = length(y);
L=size(Q,2); 
P=zeros(n,K);

%Construct Dictionary Matrix
for k=1:K
    
    P_temp = p{k}(x);
    P(:,k) = P_temp;
end



%Estimation
betahat_all = pinv([P,  Q]'*[P, Q]) * [P, Q]' * y; 
betahat=betahat_all(1:K);
betahat_h = betahat_all((K+1):end);


%Construct Estimate Function
g=@(x,b) b(1)*p{1}(x);
    for k=2:K
        g=@(x,b)g(x,b)+b(k)*p{k}(x);
    end  
ghat=@(x) g(x,betahat);

%Variance Estimation
ehat = y - [P, Q]*betahat_all;

%Project out conditioning variables
if isempty(Q)
    MIhat=eye(n);
else
    MIhat=eye(n) - Q*pinv(Q'*Q)*Q'; 
end
What = MIhat*P;
invQhat = pinv(What'*What/n);

%hhat = diag(What*invQhat*What'/n);
Sigmahat = What'*diag(ehat.^2)*What/n;

%BIC
BIC = n*log(var(ehat)) + (K+L)*log(n);
%R2
R2 = 1-var(ehat)/var(y);
disp(['R2 = ',num2str(R2)]);
    

%Inference
thetahat.ACT_Math_Overall= ave_deriv_ACT(ghat,x,'ACT_Math_Overall'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Math_Overall')   -   thetahat.ACT_Math_Overall    )/.001; end
Vhat.ACT_Math_Overall = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Math_Overall = sqrt(Vhat.ACT_Math_Overall/n); 

thetahat.ACT_English_Overall= ave_deriv_ACT(ghat,x,'ACT_English_Overall'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_English_Overall')   -   thetahat.ACT_English_Overall    )/.001; end
Vhat.ACT_English_Overall = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_English_Overall = sqrt(Vhat.ACT_English_Overall/n); 

thetahat.ACT_Reading_Overall= ave_deriv_ACT(ghat,x,'ACT_Reading_Overall'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Reading_Overall')   -   thetahat.ACT_Reading_Overall    )/.001; end
Vhat.ACT_Reading_Overall = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Reading_Overall = sqrt(Vhat.ACT_Reading_Overall/n); 

thetahat.ACT_Science_Overall= ave_deriv_ACT(ghat,x,'ACT_Science_Overall'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Science_Overall')   -   thetahat.ACT_Science_Overall    )/.001; end
Vhat.ACT_Science_Overall = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Science_Overall = sqrt(Vhat.ACT_Science_Overall/n); 




thetahat.ACT_Math_Q1= ave_deriv_ACT(ghat,x,'ACT_Math_Q1'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Math_Q1')   -   thetahat.ACT_Math_Q1    )/.001; end
Vhat.ACT_Math_Q1 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Math_Q1 = sqrt(Vhat.ACT_Math_Q1/n); 

thetahat.ACT_English_Q1= ave_deriv_ACT(ghat,x,'ACT_English_Q1'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_English_Q1')   -   thetahat.ACT_English_Q1    )/.001; end
Vhat.ACT_English_Q1 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_English_Q1 = sqrt(Vhat.ACT_English_Q1/n); 

thetahat.ACT_Reading_Q1= ave_deriv_ACT(ghat,x,'ACT_Reading_Q1'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Reading_Q1')   -   thetahat.ACT_Reading_Q1    )/.001; end
Vhat.ACT_Reading_Q1 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Reading_Q1 = sqrt(Vhat.ACT_Reading_Q1/n); 

thetahat.ACT_Science_Q1= ave_deriv_ACT(ghat,x,'ACT_Science_Q1'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Science_Q1')   -   thetahat.ACT_Science_Q1   )/.001; end
Vhat.ACT_Science_Q1 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Science_Q1 = sqrt(Vhat.ACT_Science_Q1/n); 



thetahat.ACT_Math_Q2= ave_deriv_ACT(ghat,x,'ACT_Math_Q2'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Math_Q2')   -   thetahat.ACT_Math_Q2    )/.001; end
Vhat.ACT_Math_Q2 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Math_Q2 = sqrt(Vhat.ACT_Math_Q2/n); 

thetahat.ACT_English_Q2= ave_deriv_ACT(ghat,x,'ACT_English_Q2'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_English_Q2')   -   thetahat.ACT_English_Q2    )/.001; end
Vhat.ACT_English_Q2 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_English_Q2 = sqrt(Vhat.ACT_English_Q2/n); 

thetahat.ACT_Reading_Q2= ave_deriv_ACT(ghat,x,'ACT_Reading_Q2'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Reading_Q2')   -   thetahat.ACT_Reading_Q2    )/.001; end
Vhat.ACT_Reading_Q2 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Reading_Q2 = sqrt(Vhat.ACT_Reading_Q2/n); 

thetahat.ACT_Science_Q2= ave_deriv_ACT(ghat,x,'ACT_Science_Q2'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Science_Q2')   -   thetahat.ACT_Science_Q2   )/.001; end
Vhat.ACT_Science_Q2 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Science_Q2 = sqrt(Vhat.ACT_Science_Q2/n); 






thetahat.ACT_Math_Q3= ave_deriv_ACT(ghat,x,'ACT_Math_Q3'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Math_Q3')   -   thetahat.ACT_Math_Q3    )/.001; end
Vhat.ACT_Math_Q3 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Math_Q3 = sqrt(Vhat.ACT_Math_Q3/n); 

thetahat.ACT_English_Q3= ave_deriv_ACT(ghat,x,'ACT_English_Q3'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_English_Q3')   -   thetahat.ACT_English_Q3    )/.001; end
Vhat.ACT_English_Q3 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_English_Q3 = sqrt(Vhat.ACT_English_Q3/n); 

thetahat.ACT_Reading_Q3= ave_deriv_ACT(ghat,x,'ACT_Reading_Q3'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Reading_Q3')   -   thetahat.ACT_Reading_Q3    )/.001; end
Vhat.ACT_Reading_Q3 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Reading_Q3 = sqrt(Vhat.ACT_Reading_Q3/n); 

thetahat.ACT_Science_Q3= ave_deriv_ACT(ghat,x,'ACT_Science_Q3'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Science_Q3')   -   thetahat.ACT_Science_Q3   )/.001; end
Vhat.ACT_Science_Q3 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Science_Q3 = sqrt(Vhat.ACT_Science_Q3/n); 






thetahat.ACT_Math_Q4= ave_deriv_ACT(ghat,x,'ACT_Math_Q4'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Math_Q4')   -   thetahat.ACT_Math_Q4    )/.001; end
Vhat.ACT_Math_Q4 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Math_Q4 = sqrt(Vhat.ACT_Math_Q4/n); 

thetahat.ACT_English_Q4= ave_deriv_ACT(ghat,x,'ACT_English_Q4'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_English_Q4')   -   thetahat.ACT_English_Q4    )/.001; end
Vhat.ACT_English_Q4 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_English_Q4 = sqrt(Vhat.ACT_English_Q4/n); 

thetahat.ACT_Reading_Q4= ave_deriv_ACT(ghat,x,'ACT_Reading_Q4'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Reading_Q4')   -   thetahat.ACT_Reading_Q4    )/.001; end
Vhat.ACT_Reading_Q4 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Reading_Q4 = sqrt(Vhat.ACT_Reading_Q4/n); 

thetahat.ACT_Science_Q4= ave_deriv_ACT(ghat,x,'ACT_Science_Q4'); E=eye(K)*.001; Ahat=zeros(1,K);
for k=1:K, Ahat(k) = (    ave_deriv_ACT(@(x)g(x,betahat +E(:,k)),x,'ACT_Science_Q4')   -   thetahat.ACT_Science_Q4   )/.001; end
Vhat.ACT_Science_Q4 = Ahat*invQhat*Sigmahat*invQhat*Ahat'; 
se.ACT_Science_Q4 = sqrt(Vhat.ACT_Science_Q4/n); 

























