
function [ghat, thetahat, Vhat, BIC]=nonpar_simple(y,x,p,K,Q)



n = length(y);
L=size(Q,2); 
P=zeros(n,K);

%Construct Dictionary Matrix
for k=1:K
    P_temp = p{k}(x);
    P(:,k) = P_temp;
end



%Estimation
%betahat_all = pinv([P,  Q]'*[P, Q]) * [P, Q]' * y; 
betahat_all = [P,Q]\y;
betahat=betahat_all(1:K);

%Construct Estimate Function
g=@(x,b) b(1)*p{1}(x);
    for k=2:K
        g=@(x,b)g(x,b)+b(k)*p{k}(x);
    end  
ghat=@(x) g(x,betahat);

%Variance Estimation
ehat = y - [P, Q]*betahat_all;

%Project out conditioning variables
if isempty(Q)
    MIhat=eye(n);
else
    MIhat=eye(n) - Q*pinv(Q'*Q)*Q'; 
end
What = MIhat*P;
invQhat = pinv(What'*What/n);

hhat = diag(What*invQhat*What'/n);
Sigmahat = What'*diag(ehat.^2./(1-hhat))*What/n;

%Ahat -- works Functional Specific.
x_a_unif = norminv(.01:.01:.99)';
thetahat= ave_deriv(ghat,x_a_unif);
E=eye(K)*.001;
Ahat=zeros(1,K);


for k=1:K
Ahat(k) = (    ave_deriv(@(x)g(x,betahat +E(:,k)),x_a_unif)   -   thetahat    )/.001;
end

%Final Variance Plug-In Estimate
Vhat = (n/(n-K-L))*Ahat*invQhat*Sigmahat*invQhat*Ahat'; 

BIC = n*log(var(ehat)) + (K+L)*log(n);


